diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h ns-3.40/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h
--- ns-3.39/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -22,8 +22,8 @@
 #ifndef ITU_R_1411_NLOS_OVER_ROOFTOP_PROPAGATION_LOSS_MODEL_H
 #define ITU_R_1411_NLOS_OVER_ROOFTOP_PROPAGATION_LOSS_MODEL_H
 
-#include <ns3/propagation-environment.h>
-#include <ns3/propagation-loss-model.h>
+#include "propagation-environment.h"
+#include "propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/jakes-propagation-loss-model.h ns-3.40/src/propagation/model/jakes-propagation-loss-model.h
--- ns-3.39/src/propagation/model/jakes-propagation-loss-model.h	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/jakes-propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -19,9 +19,9 @@
 #ifndef JAKES_STATIONARY_LOSS_MODEL_H
 #define JAKES_STATIONARY_LOSS_MODEL_H
 
-#include "ns3/jakes-process.h"
-#include "ns3/propagation-cache.h"
-#include "ns3/propagation-loss-model.h"
+#include "jakes-process.h"
+#include "propagation-cache.h"
+#include "propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/kun-2600-mhz-propagation-loss-model.h ns-3.40/src/propagation/model/kun-2600-mhz-propagation-loss-model.h
--- ns-3.39/src/propagation/model/kun-2600-mhz-propagation-loss-model.h	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/kun-2600-mhz-propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -22,7 +22,7 @@
 #ifndef KUN_2600MHZ_PROPAGATION_LOSS_MODEL_H
 #define KUN_2600MHZ_PROPAGATION_LOSS_MODEL_H
 
-#include <ns3/propagation-loss-model.h>
+#include "propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/okumura-hata-propagation-loss-model.cc ns-3.40/src/propagation/model/okumura-hata-propagation-loss-model.cc
--- ns-3.39/src/propagation/model/okumura-hata-propagation-loss-model.cc	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/okumura-hata-propagation-loss-model.cc	2023-09-27 13:30:37.866839600 -0700
@@ -25,6 +25,7 @@
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
 
+#include <algorithm>
 #include <cmath>
 
 namespace ns3
@@ -80,19 +81,28 @@
 {
     double loss = 0.0;
     double fmhz = m_frequency / 1e6;
-    double dist = a->GetDistanceFrom(b) / 1000.0;
+    double log_fMhz = std::log10(fmhz);
+    // In the Okumura Hata literature, the distance is expressed in units of kilometers
+    // but other lengths are expressed in meters
+    double distKm = a->GetDistanceFrom(b) / 1000.0;
+
+    Vector aPosition = a->GetPosition();
+    Vector bPosition = b->GetPosition();
+
+    double hb = std::max(aPosition.z, bPosition.z);
+    double hm = std::min(aPosition.z, bPosition.z);
+
+    NS_ASSERT_MSG(hb > 0 && hm > 0, "nodes' height must be greater then 0");
+
+    double log_hb = std::log10(hb);
+    double log_aHeight = 13.82 * log_hb;
+    double log_bHeight = 0.0;
+
     if (m_frequency <= 1.500e9)
     {
         // standard Okumura Hata
         // see eq. (4.4.1) in the COST 231 final report
-        double log_f = std::log10(fmhz);
-        double hb =
-            (a->GetPosition().z > b->GetPosition().z ? a->GetPosition().z : b->GetPosition().z);
-        double hm =
-            (a->GetPosition().z < b->GetPosition().z ? a->GetPosition().z : b->GetPosition().z);
-        NS_ASSERT_MSG(hb > 0 && hm > 0, "nodes' height must be greater then 0");
-        double log_aHeight = 13.82 * std::log10(hb);
-        double log_bHeight = 0.0;
+
         if (m_citySize == LargeCity)
         {
             if (fmhz < 200)
@@ -106,21 +116,21 @@
         }
         else
         {
-            log_bHeight = 0.8 + (1.1 * log_f - 0.7) * hm - 1.56 * log_f;
+            log_bHeight = 0.8 + (1.1 * log_fMhz - 0.7) * hm - 1.56 * log_fMhz;
         }
 
-        NS_LOG_INFO(this << " logf " << 26.16 * log_f << " loga " << log_aHeight << " X "
-                         << (((44.9 - (6.55 * std::log10(hb)))) * std::log10(a->GetDistanceFrom(b)))
-                         << " logb " << log_bHeight);
-        loss = 69.55 + (26.16 * log_f) - log_aHeight +
-               (((44.9 - (6.55 * std::log10(hb)))) * std::log10(dist)) - log_bHeight;
+        NS_LOG_INFO(this << " logf " << 26.16 * log_fMhz << " loga " << log_aHeight << " X "
+                         << ((44.9 - (6.55 * log_hb)) * std::log10(distKm)) << " logb "
+                         << log_bHeight);
+        loss = 69.55 + (26.16 * log_fMhz) - log_aHeight +
+               ((44.9 - (6.55 * log_hb)) * std::log10(distKm)) - log_bHeight;
         if (m_environment == SubUrbanEnvironment)
         {
             loss += -2 * (std::pow(std::log10(fmhz / 28), 2)) - 5.4;
         }
         else if (m_environment == OpenAreasEnvironment)
         {
-            loss += -4.70 * std::pow(std::log10(fmhz), 2) + 18.33 * std::log10(fmhz) - 40.94;
+            loss += -4.70 * std::pow(log_fMhz, 2) + 18.33 * log_fMhz - 40.94;
         }
     }
     else
@@ -128,28 +138,20 @@
         // COST 231 Okumura model
         // see eq. (4.4.3) in the COST 231 final report
 
-        double log_f = std::log10(fmhz);
-        double hb =
-            (a->GetPosition().z > b->GetPosition().z ? a->GetPosition().z : b->GetPosition().z);
-        double hm =
-            (a->GetPosition().z < b->GetPosition().z ? a->GetPosition().z : b->GetPosition().z);
-        NS_ASSERT_MSG(hb > 0 && hm > 0, "nodes' height must be greater then 0");
-        double log_aHeight = 13.82 * std::log10(hb);
-        double log_bHeight = 0.0;
         double C = 0.0;
 
         if (m_citySize == LargeCity)
         {
-            log_bHeight = 3.2 * std::pow((std::log10(11.75 * hm)), 2);
+            log_bHeight = 3.2 * std::pow(std::log10(11.75 * hm), 2);
             C = 3;
         }
         else
         {
-            log_bHeight = (1.1 * log_f - 0.7) * hm - (1.56 * log_f - 0.8);
+            log_bHeight = (1.1 * log_fMhz - 0.7) * hm - (1.56 * log_fMhz - 0.8);
         }
 
-        loss = 46.3 + (33.9 * log_f) - log_aHeight +
-               (((44.9 - (6.55 * std::log10(hb)))) * std::log10(dist)) - log_bHeight + C;
+        loss = 46.3 + (33.9 * log_fMhz) - log_aHeight +
+               ((44.9 - (6.55 * log_hb)) * std::log10(distKm)) - log_bHeight + C;
     }
     return loss;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/okumura-hata-propagation-loss-model.h ns-3.40/src/propagation/model/okumura-hata-propagation-loss-model.h
--- ns-3.39/src/propagation/model/okumura-hata-propagation-loss-model.h	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/okumura-hata-propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -22,8 +22,8 @@
 #ifndef OKUMURA_HATA_PROPAGATION_LOSS_MODEL_H
 #define OKUMURA_HATA_PROPAGATION_LOSS_MODEL_H
 
-#include <ns3/propagation-environment.h>
-#include <ns3/propagation-loss-model.h>
+#include "propagation-environment.h"
+#include "propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/probabilistic-v2v-channel-condition-model.h ns-3.40/src/propagation/model/probabilistic-v2v-channel-condition-model.h
--- ns-3.39/src/propagation/model/probabilistic-v2v-channel-condition-model.h	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/probabilistic-v2v-channel-condition-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -19,7 +19,7 @@
 #ifndef PROBABILISTIC_V2V_CHANNEL_CONDITION_MODEL_H
 #define PROBABILISTIC_V2V_CHANNEL_CONDITION_MODEL_H
 
-#include "ns3/channel-condition-model.h"
+#include "channel-condition-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/propagation-cache.h ns-3.40/src/propagation/model/propagation-cache.h
--- ns-3.39/src/propagation/model/propagation-cache.h	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/propagation-cache.h	2023-09-27 13:30:37.866839600 -0700
@@ -48,7 +48,7 @@
     Ptr<T> GetPathData(Ptr<const MobilityModel> a, Ptr<const MobilityModel> b, uint32_t modelUid)
     {
         PropagationPathIdentifier key = PropagationPathIdentifier(a, b, modelUid);
-        typename PathCache::iterator it = m_pathCache.find(key);
+        auto it = m_pathCache.find(key);
         if (it == m_pathCache.end())
         {
             return nullptr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/propagation-loss-model.cc ns-3.40/src/propagation/model/propagation-loss-model.cc
--- ns-3.39/src/propagation/model/propagation-loss-model.cc	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/propagation-loss-model.cc	2023-09-27 13:30:37.866839600 -0700
@@ -747,7 +747,7 @@
 
     // switch between Erlang- and Gamma distributions: this is only for
     // speed. (Gamma is equal to Erlang for any positive integer m.)
-    unsigned int int_m = static_cast<unsigned int>(std::floor(m));
+    auto int_m = static_cast<unsigned int>(std::floor(m));
 
     if (int_m == m)
     {
@@ -869,7 +869,7 @@
     NS_ASSERT(ma && mb);
 
     MobilityPair p = std::make_pair(ma, mb);
-    std::map<MobilityPair, double>::iterator i = m_loss.find(p);
+    auto i = m_loss.find(p);
 
     if (i == m_loss.end())
     {
@@ -891,7 +891,7 @@
                                           Ptr<MobilityModel> a,
                                           Ptr<MobilityModel> b) const
 {
-    std::map<MobilityPair, double>::const_iterator i = m_loss.find(std::make_pair(a, b));
+    auto i = m_loss.find(std::make_pair(a, b));
 
     if (i != m_loss.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.cc ns-3.40/src/propagation/model/three-gpp-propagation-loss-model.cc
--- ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.cc	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/three-gpp-propagation-loss-model.cc	2023-09-27 13:30:37.866839600 -0700
@@ -18,8 +18,9 @@
 
 #include "three-gpp-propagation-loss-model.h"
 
+#include "channel-condition-model.h"
+
 #include "ns3/boolean.h"
-#include "ns3/channel-condition-model.h"
 #include "ns3/double.h"
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.h ns-3.40/src/propagation/model/three-gpp-propagation-loss-model.h
--- ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.h	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/propagation/model/three-gpp-propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
@@ -19,8 +19,8 @@
 #ifndef THREE_GPP_PROPAGATION_LOSS_MODEL_H
 #define THREE_GPP_PROPAGATION_LOSS_MODEL_H
 
-#include "ns3/channel-condition-model.h"
-#include "ns3/propagation-loss-model.h"
+#include "channel-condition-model.h"
+#include "propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/sixlowpan/CMakeLists.txt ns-3.40/src/sixlowpan/CMakeLists.txt
--- ns-3.39/src/sixlowpan/CMakeLists.txt	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/sixlowpan/CMakeLists.txt	2023-09-27 13:30:37.866839600 -0700
@@ -17,8 +17,6 @@
     model/sixlowpan-net-device.h
   LIBRARIES_TO_LINK
     ${libinternet}
-    ${libinternet}
-    ${libcore}
   TEST_SOURCES
     ${example_as_test_suite}
     test/mock-net-device.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/sixlowpan/helper/sixlowpan-helper.cc ns-3.40/src/sixlowpan/helper/sixlowpan-helper.cc
--- ns-3.39/src/sixlowpan/helper/sixlowpan-helper.cc	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/sixlowpan/helper/sixlowpan-helper.cc	2023-09-27 13:30:37.866839600 -0700
@@ -140,7 +140,7 @@
 {
     int64_t currentStream = stream;
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<SixLowPanNetDevice> dev = DynamicCast<SixLowPanNetDevice>(netDevice);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/sixlowpan/model/sixlowpan-net-device.cc ns-3.40/src/sixlowpan/model/sixlowpan-net-device.cc
--- ns-3.39/src/sixlowpan/model/sixlowpan-net-device.cc	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/sixlowpan/model/sixlowpan-net-device.cc	2023-09-27 13:30:37.866839600 -0700
@@ -192,7 +192,7 @@
         m_timeoutEvent.Cancel();
     }
 
-    for (MapFragmentsI_t iter = m_fragments.begin(); iter != m_fragments.end(); iter++)
+    for (auto iter = m_fragments.begin(); iter != m_fragments.end(); iter++)
     {
         iter->second = nullptr;
     }
@@ -666,9 +666,8 @@
         // fragment
         std::list<Ptr<Packet>> fragmentList;
         DoFragmentation(packet, origPacketSize, origHdrSize, extraHdrSize, fragmentList);
-        std::list<Ptr<Packet>>::iterator it;
         bool success = true;
-        for (it = fragmentList.begin(); it != fragmentList.end(); it++)
+        for (auto it = fragmentList.begin(); it != fragmentList.end(); it++)
         {
             NS_LOG_DEBUG("SixLowPanNetDevice::Send (Fragment) " << **it);
             m_txTrace(*it, this, GetIfIndex());
@@ -2343,7 +2342,7 @@
     uint32_t packetSize = packet->GetSize();
     uint32_t compressedHeaderSize = packetSize - (origPacketSize - origHdrSize);
 
-    uint16_t tag = uint16_t(m_rng->GetValue(0, 65535));
+    auto tag = static_cast<uint16_t>(m_rng->GetValue(0, 65535));
     NS_LOG_LOGIC("random tag " << tag << " - test " << packetSize);
 
     // first fragment
@@ -2474,18 +2473,17 @@
 
     Ptr<Fragments> fragments;
 
-    MapFragments_t::iterator it = m_fragments.find(key);
+    auto it = m_fragments.find(key);
     if (it == m_fragments.end())
     {
         // erase the oldest packet.
         if (m_fragmentReassemblyListSize && (m_fragments.size() >= m_fragmentReassemblyListSize))
         {
-            FragmentsTimeoutsListI_t iter = m_timeoutEventList.begin();
+            auto iter = m_timeoutEventList.begin();
             FragmentKey_t oldestKey = std::get<1>(*iter);
 
             std::list<Ptr<Packet>> storedFragments = m_fragments[oldestKey]->GetFragments();
-            for (std::list<Ptr<Packet>>::iterator fragIter = storedFragments.begin();
-                 fragIter != storedFragments.end();
+            for (auto fragIter = storedFragments.begin(); fragIter != storedFragments.end();
                  fragIter++)
             {
                 m_dropTrace(DROP_FRAGMENT_BUFFER_FULL, *fragIter, this, GetIfIndex());
@@ -2500,7 +2498,7 @@
         m_fragments.insert(std::make_pair(key, fragments));
         uint32_t ifIndex = GetIfIndex();
 
-        FragmentsTimeoutsListI_t iter = SetTimeout(key, ifIndex);
+        auto iter = SetTimeout(key, ifIndex);
         fragments->SetTimeoutIter(iter);
     }
     else
@@ -2592,9 +2590,7 @@
 
     if (ret)
     {
-        for (std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it = m_fragments.begin();
-             it != m_fragments.end();
-             it++)
+        for (auto it = m_fragments.begin(); it != m_fragments.end(); it++)
         {
             // overlapping fragments should not exist
             NS_LOG_LOGIC("Checking overlaps " << lastEndOffset << " - " << it->second);
@@ -2618,7 +2614,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it = m_fragments.begin();
+    auto it = m_fragments.begin();
 
     Ptr<Packet> p = Create<Packet>();
     uint16_t lastEndOffset = 0;
@@ -2655,8 +2651,7 @@
 SixLowPanNetDevice::Fragments::GetFragments() const
 {
     std::list<Ptr<Packet>> fragments;
-    std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator iter;
-    for (iter = m_fragments.begin(); iter != m_fragments.end(); iter++)
+    for (auto iter = m_fragments.begin(); iter != m_fragments.end(); iter++)
     {
         fragments.push_back(iter->first);
     }
@@ -2680,11 +2675,9 @@
 {
     NS_LOG_FUNCTION(this);
 
-    MapFragments_t::iterator it = m_fragments.find(key);
+    auto it = m_fragments.find(key);
     std::list<Ptr<Packet>> storedFragments = it->second->GetFragments();
-    for (std::list<Ptr<Packet>>::iterator fragIter = storedFragments.begin();
-         fragIter != storedFragments.end();
-         fragIter++)
+    for (auto fragIter = storedFragments.begin(); fragIter != storedFragments.end(); fragIter++)
     {
         m_dropTrace(DROP_FRAGMENT_TIMEOUT, *fragIter, this, iif);
     }
@@ -2719,7 +2712,7 @@
     }
     m_timeoutEventList.emplace_back(Simulator::Now() + m_fragmentExpirationTimeout, key, iif);
 
-    SixLowPanNetDevice::FragmentsTimeoutsListI_t iter = --m_timeoutEventList.end();
+    auto iter = --m_timeoutEventList.end();
 
     return (iter);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/sixlowpan/test/sixlowpan-example-ping-lr-wpan.reflog ns-3.40/src/sixlowpan/test/sixlowpan-example-ping-lr-wpan.reflog
--- ns-3.39/src/sixlowpan/test/sixlowpan-example-ping-lr-wpan.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.40/src/sixlowpan/test/sixlowpan-example-ping-lr-wpan.reflog	2023-09-27 13:30:37.866839600 -0700
@@ -0,0 +1,16 @@
+Device 0: pseudo-Mac-48 02:00:00:00:00:01, IPv6 Address 2001:2::ff:fe00:1
+Device 1: pseudo-Mac-48 02:00:00:00:00:02, IPv6 Address 2001:2::ff:fe00:2
+PING 2001:2::ff:fe00:2 - 16 bytes of data; 64 bytes including ICMP and IPv6 headers.
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=0 ttl=64 time=21.536 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=1 ttl=64 time=9.312 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=2 ttl=64 time=8.992 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=3 ttl=64 time=9.952 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=4 ttl=64 time=6.752 ms
+
+--- 2001:2::ff:fe00:2 ping statistics ---
+5 packets transmitted, 5 received, 0% packet loss, time 4006ms
+rtt min/avg/max/mdev = 6/10.6/21/5.941 ms
+NDISC Cache of node 0 at time +9s
+2001:2::ff:fe00:2 dev 2 lladdr 00-06-02:00:00:00:00:02 REACHABLE
+NDISC Cache of node 1 at time +9s
+2001:2::ff:fe00:1 dev 2 lladdr 00-06-02:00:00:00:00:01 REACHABLE
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/sixlowpan/test/sixlowpan-examples-test-suite.cc ns-3.40/src/sixlowpan/test/sixlowpan-examples-test-suite.cc
--- ns-3.39/src/sixlowpan/test/sixlowpan-examples-test-suite.cc	2023-07-05 14:23:48.073428200 -0700
+++ ns-3.40/src/sixlowpan/test/sixlowpan-examples-test-suite.cc	2023-09-27 13:30:37.866839600 -0700
@@ -1,7 +1,7 @@
 #include "ns3/example-as-test.h"
 
 static ns3::ExampleAsTestSuite g_sixlowpanExample(
-    "example-ping-lr-wpan",
+    "sixlowpan-example-ping-lr-wpan",
     "example-ping-lr-wpan",
     NS_TEST_SOURCEDIR,
     "--disable-pcap --disable-asciitrace --enable-sixlowpan-loginfo");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc ns-3.40/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc
--- ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc	2023-07-05 14:23:48.077428300 -0700
+++ ns-3.40/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
@@ -110,14 +110,9 @@
 void
 GlobalPathlossDatabase::Print()
 {
-    for (std::map<uint32_t, std::map<uint32_t, double>>::const_iterator txit =
-             m_pathlossMap.begin();
-         txit != m_pathlossMap.end();
-         ++txit)
+    for (auto txit = m_pathlossMap.begin(); txit != m_pathlossMap.end(); ++txit)
     {
-        for (std::map<uint32_t, double>::const_iterator rxit = txit->second.begin();
-             rxit != txit->second.end();
-             ++rxit)
+        for (auto rxit = txit->second.begin(); rxit != txit->second.end(); ++rxit)
         {
             std::cout << txit->first << " --> " << rxit->first << " : " << rxit->second << " dB"
                       << std::endl;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/helper/adhoc-aloha-noack-ideal-phy-helper.cc ns-3.40/src/spectrum/helper/adhoc-aloha-noack-ideal-phy-helper.cc
--- ns-3.39/src/spectrum/helper/adhoc-aloha-noack-ideal-phy-helper.cc	2023-07-05 14:23:48.077428300 -0700
+++ ns-3.40/src/spectrum/helper/adhoc-aloha-noack-ideal-phy-helper.cc	2023-09-27 13:30:37.874839800 -0700
@@ -91,7 +91,7 @@
 AdhocAlohaNoackIdealPhyHelper::Install(NodeContainer c) const
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/helper/spectrum-analyzer-helper.cc ns-3.40/src/spectrum/helper/spectrum-analyzer-helper.cc
--- ns-3.39/src/spectrum/helper/spectrum-analyzer-helper.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/helper/spectrum-analyzer-helper.cc	2023-09-27 13:30:37.874839800 -0700
@@ -51,8 +51,8 @@
     std::ostream* ostream = streamWrapper->GetStream();
     if (ostream->good())
     {
-        Bands::const_iterator fi = avgPowerSpectralDensity->ConstBandsBegin();
-        Values::const_iterator vi = avgPowerSpectralDensity->ConstValuesBegin();
+        auto fi = avgPowerSpectralDensity->ConstBandsBegin();
+        auto vi = avgPowerSpectralDensity->ConstValuesBegin();
         while (fi != avgPowerSpectralDensity->ConstBandsEnd())
         {
             NS_ASSERT(vi != avgPowerSpectralDensity->ConstValuesEnd());
@@ -126,7 +126,7 @@
 {
     NS_LOG_FUNCTION(this);
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/helper/tv-spectrum-transmitter-helper.cc ns-3.40/src/spectrum/helper/tv-spectrum-transmitter-helper.cc
--- ns-3.39/src/spectrum/helper/tv-spectrum-transmitter-helper.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/helper/tv-spectrum-transmitter-helper.cc	2023-09-27 13:30:37.874839800 -0700
@@ -133,7 +133,7 @@
     NS_LOG_FUNCTION(this);
     NetDeviceContainer devCont;
     // iterate over node container to make one transmitter for each given node
-    for (NodeContainer::Iterator i = nodeCont.Begin(); i != nodeCont.End(); ++i)
+    for (auto i = nodeCont.Begin(); i != nodeCont.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<TvSpectrumTransmitter> phy = m_factory.Create()->GetObject<TvSpectrumTransmitter>();
@@ -193,7 +193,7 @@
             japanEndFrequencies[channelNumber] - japanStartFrequencies[channelNumber];
     }
     // iterate over node container to make one transmitter for each given node
-    for (NodeContainer::Iterator i = nodeCont.Begin(); i != nodeCont.End(); ++i)
+    for (auto i = nodeCont.Begin(); i != nodeCont.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<TvSpectrumTransmitter> phy = m_factory.Create()->GetObject<TvSpectrumTransmitter>();
@@ -226,7 +226,7 @@
     DoubleValue startFrequency;
     DoubleValue channelBandwidth;
     // iterate over node container to make one transmitter for each given node
-    for (NodeContainer::Iterator i = nodeCont.Begin(); i != nodeCont.End(); ++i)
+    for (auto i = nodeCont.Begin(); i != nodeCont.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<TvSpectrumTransmitter> phy = m_factory.Create()->GetObject<TvSpectrumTransmitter>();
@@ -265,7 +265,7 @@
     uint16_t currChannelNumber;
     int index = 0;
     // iterate over node container to make one transmitter for each given node
-    for (NodeContainer::Iterator i = nodeCont.Begin(); i != nodeCont.End(); ++i)
+    for (auto i = nodeCont.Begin(); i != nodeCont.End(); ++i)
     {
         currChannelNumber = channelNumber + index;
         if (region == REGION_NORTH_AMERICA)
@@ -461,7 +461,7 @@
         tvNode.Create(1);
         mobility.Install(tvNode);
         // set channel number for this transmitter
-        uint16_t channelNumber = (uint16_t)transmitterIndicesToCreate.front();
+        auto channelNumber = (uint16_t)transmitterIndicesToCreate.front();
         Install(tvNode, region, channelNumber); // install tv transmitter
         transmitterLocations.pop_front();       // remove created transmitter location
         transmitterIndicesToCreate.pop_front(); // remove created transmitter index
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/helper/waveform-generator-helper.cc ns-3.40/src/spectrum/helper/waveform-generator-helper.cc
--- ns-3.39/src/spectrum/helper/waveform-generator-helper.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/helper/waveform-generator-helper.cc	2023-09-27 13:30:37.874839800 -0700
@@ -82,7 +82,7 @@
 WaveformGeneratorHelper::Install(NodeContainer c) const
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/constant-spectrum-propagation-loss.cc ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.cc
--- ns-3.39/src/spectrum/model/constant-spectrum-propagation-loss.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.cc	2023-09-27 13:30:37.874839800 -0700
@@ -17,7 +17,7 @@
  * Author: Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include "ns3/constant-spectrum-propagation-loss.h"
+#include "constant-spectrum-propagation-loss.h"
 
 #include "spectrum-signal-parameters.h"
 
@@ -84,8 +84,8 @@
     NS_LOG_FUNCTION(this);
 
     Ptr<SpectrumValue> rxPsd = Copy<SpectrumValue>(params->psd);
-    Values::iterator vit = rxPsd->ValuesBegin();
-    Bands::const_iterator fit = rxPsd->ConstBandsBegin();
+    auto vit = rxPsd->ValuesBegin();
+    auto fit = rxPsd->ConstBandsBegin();
 
     while (vit != rxPsd->ValuesEnd())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/constant-spectrum-propagation-loss.h ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.h
--- ns-3.39/src/spectrum/model/constant-spectrum-propagation-loss.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,7 +20,7 @@
 #ifndef CONSTANT_SPECTRUM_PROPAGATION_LOSS_H
 #define CONSTANT_SPECTRUM_PROPAGATION_LOSS_H
 
-#include "ns3/spectrum-propagation-loss-model.h"
+#include "spectrum-propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/friis-spectrum-propagation-loss.cc ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.cc
--- ns-3.39/src/spectrum/model/friis-spectrum-propagation-loss.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.cc	2023-09-27 13:30:37.874839800 -0700
@@ -17,9 +17,10 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
+#include "friis-spectrum-propagation-loss.h"
+
 #include "spectrum-signal-parameters.h"
 
-#include <ns3/friis-spectrum-propagation-loss.h>
 #include <ns3/mobility-model.h>
 
 #include <cmath> // for M_PI
@@ -54,8 +55,8 @@
     Ptr<const MobilityModel> b) const
 {
     Ptr<SpectrumValue> rxPsd = Copy<SpectrumValue>(params->psd);
-    Values::iterator vit = rxPsd->ValuesBegin();
-    Bands::const_iterator fit = rxPsd->ConstBandsBegin();
+    auto vit = rxPsd->ValuesBegin();
+    auto fit = rxPsd->ConstBandsBegin();
 
     NS_ASSERT(a);
     NS_ASSERT(b);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/friis-spectrum-propagation-loss.h ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.h
--- ns-3.39/src/spectrum/model/friis-spectrum-propagation-loss.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,7 +20,7 @@
 #ifndef FRIIS_SPECTRUM_PROPAGATION_LOSS_H
 #define FRIIS_SPECTRUM_PROPAGATION_LOSS_H
 
-#include <ns3/spectrum-propagation-loss-model.h>
+#include "spectrum-propagation-loss-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/half-duplex-ideal-phy.h ns-3.40/src/spectrum/model/half-duplex-ideal-phy.h
--- ns-3.39/src/spectrum/model/half-duplex-ideal-phy.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/half-duplex-ideal-phy.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,6 +20,12 @@
 #ifndef HALF_DUPLEX_IDEAL_PHY_H
 #define HALF_DUPLEX_IDEAL_PHY_H
 
+#include "spectrum-channel.h"
+#include "spectrum-interference.h"
+#include "spectrum-phy.h"
+#include "spectrum-signal-parameters.h"
+#include "spectrum-value.h"
+
 #include <ns3/data-rate.h>
 #include <ns3/event-id.h>
 #include <ns3/generic-phy.h>
@@ -27,11 +33,6 @@
 #include <ns3/net-device.h>
 #include <ns3/nstime.h>
 #include <ns3/packet.h>
-#include <ns3/spectrum-channel.h>
-#include <ns3/spectrum-interference.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-signal-parameters.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h ns-3.40/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h
--- ns-3.39/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,7 +20,7 @@
 #ifndef HALF_DUPLEX_IDEAL_PHY_SPECTRUM_PARAMETERS_H
 #define HALF_DUPLEX_IDEAL_PHY_SPECTRUM_PARAMETERS_H
 
-#include <ns3/spectrum-signal-parameters.h>
+#include "spectrum-signal-parameters.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/ism-spectrum-value-helper.h ns-3.40/src/spectrum/model/ism-spectrum-value-helper.h
--- ns-3.39/src/spectrum/model/ism-spectrum-value-helper.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/ism-spectrum-value-helper.h	2023-09-27 13:30:37.874839800 -0700
@@ -22,7 +22,7 @@
 #ifndef ISM_SPECTRUM_VALUE_HELPER_H
 #define ISM_SPECTRUM_VALUE_HELPER_H
 
-#include <ns3/spectrum-value.h>
+#include "spectrum-value.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/microwave-oven-spectrum-value-helper.h ns-3.40/src/spectrum/model/microwave-oven-spectrum-value-helper.h
--- ns-3.39/src/spectrum/model/microwave-oven-spectrum-value-helper.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/microwave-oven-spectrum-value-helper.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,7 +20,7 @@
 #ifndef MICROWAVE_OVEN_SPECTRUM_VALUE_HELPER_H
 #define MICROWAVE_OVEN_SPECTRUM_VALUE_HELPER_H
 
-#include <ns3/spectrum-value.h>
+#include "spectrum-value.h"
 
 namespace ns3
 {
